<?php
require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('multishop').'pi1/classes/class.tx_mslib_cart.php');
$mslib_cart=\TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('tx_mslib_cart');
$mslib_cart->init($this);
$cart=$mslib_cart->getCart();
if ($this->ms['MODULES']['DISABLE_VAT_RATE_WHEN_CROSS_BORDERS']) {
	// if store country is different than customer country change VAT rate to zero
	if ($cart['user']['country']) {
		$iso_customer=mslib_fe::getCountryByName($cart['user']['country']);
		if ($iso_customer['cn_iso_nr']!=$this->ms['MODULES']['COUNTRY_ISO_NR']) {
			$this->ms['MODULES']['DISABLE_VAT_RATE']=1;
		}
	}
	// if store country is different than customer country change VAT rate to zero eof
}
if (count($cart['products'])<1) {
	$content.='<div class="noitems_message">'.$this->pi_getLL('there_are_no_products_in_your_cart').'</div>';
} else {
	if (mslib_fe::loggedin()) {
		if (isset($cart['user']['first_name']) && isset($cart['user']['street_name'])) {
			$user=$cart['user'];
		} else {
			$user=array();
			$billing_address=mslib_fe::getFeUserTTaddressDetails($GLOBALS['TSFE']->fe_user->user['uid'], 'billing');
			$delivery_address=mslib_fe::getFeUserTTaddressDetails($GLOBALS['TSFE']->fe_user->user['uid'], 'delivery');
			// custom page hook that can be controlled by third-party plugin
			if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/scripts/front_pages/includes/checkout']['checkoutFeUserGetTTaddressDetails'])) {
				$params=array(
					'billing_address'=>&$billing_address,
					'delivery_address'=>&$delivery_address,
					'user'=>&$user,
					'mslib_cart'=>&$mslib_cart
				);
				foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/scripts/front_pages/includes/checkout']['checkoutFeUserGetTTaddressDetails'] as $funcRef) {
					\TYPO3\CMS\Core\Utility\GeneralUtility::callUserFunction($funcRef, $params, $this);
				}
			}
			// custom page hook that can be controlled by third-party plugin eof
			if (is_array($billing_address)) {
				$user['first_name']=$billing_address['first_name'];
				$user['middle_name']=$billing_address['middle_name'];
				$user['last_name']=$billing_address['last_name'];
				if ($billing_address['gender']=='m' or $billing_address['gender']=='0') {
					$user['gender']='m';
				} elseif ($billing_address['gender']=='f' or $billing_address['gender']=='1') {
					$user['gender']='f';
				}
				$user['company']=$billing_address['company'];
				$user['tx_multishop_newsletter']=$billing_address['tx_multishop_newsletter'];
				$user['address_ext']=$billing_address['address_ext'];
				$user['street_name']=$billing_address['street_name'];
				$user['address_number']=$billing_address['address_number'];
				$user['address']=$billing_address['street_name'].' '.$billing_address['address_number'].($billing_address['address_ext'] ? '-'.$billing_address['address_ext'] : '');
				$user['address']=preg_replace('/\s+/', ' ', $user['address']);
				$user['zip']=$billing_address['zip'];
				$user['city']=$billing_address['city'];
				if ($this->ms['MODULES']['CHECKOUT_ENABLE_STATE']) {
					$user['state']=$billing_address['state'];
				}
				$user['email']=$billing_address['email'];
				$user['telephone']=$billing_address['phone'];
				$user['mobile']=$billing_address['mobile'];
				$user['country']=$billing_address['country'];
			} else {
				$user=array();
				$user['first_name']=$GLOBALS['TSFE']->fe_user->user['first_name'];
				$user['middle_name']=$GLOBALS['TSFE']->fe_user->user['middle_name'];
				$user['last_name']=$GLOBALS['TSFE']->fe_user->user['last_name'];
				$user['gender']=($GLOBALS['TSFE']->fe_user->user['gender']==0 ? "m" : "f");
				$user['company']=$GLOBALS['TSFE']->fe_user->user['company'];
				$user['tx_multishop_newsletter']=$GLOBALS['TSFE']->fe_user->user['tx_multishop_newsletter'];
				$user['address_ext']=$GLOBALS['TSFE']->fe_user->user['address_ext'];
				$user['street_name']=$GLOBALS['TSFE']->fe_user->user['street_name'];
				$user['address_number']=$GLOBALS['TSFE']->fe_user->user['address_number'];
				$user['address']=$GLOBALS['TSFE']->fe_user->user['street_name'].' '.$GLOBALS['TSFE']->fe_user->user['address_number'].($GLOBALS['TSFE']->fe_user->user['address_ext'] ? '-'.$GLOBALS['TSFE']->fe_user->user['address_ext'] : '');
				$user['address']=preg_replace('/\s+/', ' ', $user['address']);
				$user['zip']=$GLOBALS['TSFE']->fe_user->user['zip'];
				$user['city']=$GLOBALS['TSFE']->fe_user->user['city'];
				if ($this->ms['MODULES']['CHECKOUT_ENABLE_STATE']) {
					$user['state']=$GLOBALS['TSFE']->fe_user->user['state'];
					$user['delivery_state']=$GLOBALS['TSFE']->fe_user->user['delivery_state'];
				}
				$user['email']=$GLOBALS['TSFE']->fe_user->user['email'];
				$user['telephone']=$GLOBALS['TSFE']->fe_user->user['telephone'];
				$user['mobile']=$GLOBALS['TSFE']->fe_user->user['mobile'];
				$user['country']=$GLOBALS['TSFE']->fe_user->user['country'];
			}
			if ($this->ms['MODULES']['CHECKOUT_DISPLAY_VAT_ID_INPUT'] && !empty($GLOBALS['TSFE']->fe_user->user['tx_multishop_vat_id'])) {
				$user['tx_multishop_vat_id']=$GLOBALS['TSFE']->fe_user->user['tx_multishop_vat_id'];
			}
			if ($this->ms['MODULES']['CHECKOUT_DISPLAY_COC_ID_INPUT'] && !empty($GLOBALS['TSFE']->fe_user->user['tx_multishop_coc_id'])) {
				$user['tx_multishop_coc_id']=$GLOBALS['TSFE']->fe_user->user['tx_multishop_coc_id'];
			}
			if (is_array($delivery_address)) {
				$user['delivery_first_name']=$delivery_address['first_name'];
				$user['delivery_middle_name']=$delivery_address['middle_name'];
				$user['delivery_last_name']=$delivery_address['last_name'];
				if ($delivery_address['gender']=='m' or $delivery_address['gender']=='0') {
					$user['delivery_gender']='m';
				} elseif ($delivery_address['gender']=='f' or $delivery_address['gender']=='1') {
					$user['delivery_gender']='f';
				}
				$user['delivery_company']=$delivery_address['company'];
				$user['delivery_tx_multishop_newsletter']=$delivery_address['tx_multishop_newsletter'];
				$user['delivery_address_ext']=$delivery_address['address_ext'];
				$user['delivery_street_name']=$delivery_address['street_name'];
				$user['delivery_address_number']=$delivery_address['address_number'];
				$user['delivery_address']=$delivery_address['street_name'].' '.$delivery_address['address_number'].($delivery_address['address_ext'] ? '-'.$delivery_address['address_ext'] : '');
				$user['delivery_address']=preg_replace('/\s+/', ' ', $user['delivery_address']);
				$user['delivery_zip']=$delivery_address['zip'];
				$user['delivery_city']=$delivery_address['city'];
				if ($this->ms['MODULES']['CHECKOUT_ENABLE_STATE']) {
					$user['delivery_state']=$delivery_address['state'];
				}
				$user['delivery_email']=$delivery_address['email'];
				$user['delivery_telephone']=$delivery_address['phone'];
				$user['delivery_mobile']=$delivery_address['mobile'];
				$user['delivery_country']=$delivery_address['country'];
			}
		}
	} else {
		$user=$cart['user'];
	}
	// custom page hook that can be controlled by third-party plugin
	if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/scripts/front_pages/includes/checkout']['checkoutFeUserPostProc'])) {
		$params=array(
			'user'=>&$user,
			'mslib_cart'=>&$mslib_cart
		);
		foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/scripts/front_pages/includes/checkout']['checkoutFeUserPostProc'] as $funcRef) {
			\TYPO3\CMS\Core\Utility\GeneralUtility::callUserFunction($funcRef, $params, $this);
		}
	}
	// custom page hook that can be controlled by third-party plugin eof
	if ($this->posted_page==current($stepCodes)) {
		// now verify the posted values
		if (!$this->post['email']) {
			$erno[]=ucfirst($this->pi_getLL('no_email_address_has_been_specified'));
		}
		if (!$this->post['street_name']) {
			$erno[]=ucfirst($this->pi_getLL('street_address_is_required'));
		}
		if (!$this->post['address_number']) {
			$erno[]=ucfirst($this->pi_getLL('street_number_is_required'));
		}
		if (!$this->post['first_name']) {
			$erno[]=ucfirst($this->pi_getLL('first_name_required'));
		}
		if (!$this->post['last_name']) {
			$erno[]=ucfirst($this->pi_getLL('surname_is_required'));
		}
		if (!$this->post['zip']) {
			$erno[]=ucfirst($this->pi_getLL('zip_is_required'));
		}
		if (!$this->post['city']) {
			$erno[]=ucfirst($this->pi_getLL('city_is_required'));
		}
		if ($this->post['different_delivery_address']) {
			if (!$this->post['delivery_street_name']) {
				$erno[]=ucfirst($this->pi_getLL('delivery_street_address_is_required'));
			}
			if (!$this->post['delivery_address_number']) {
				$erno[]=ucfirst($this->pi_getLL('delivery_street_number_is_required'));
			}
			if (!$this->post['delivery_first_name']) {
				$erno[]=ucfirst($this->pi_getLL('delivery_first_name_required'));
			}
			if (!$this->post['delivery_last_name']) {
				$erno[]=ucfirst($this->pi_getLL('delivery_surname_is_required'));
			}
			if (!$this->post['delivery_zip']) {
				$erno[]=ucfirst($this->pi_getLL('delivery_zip_is_required'));
			}
			if (!$this->post['delivery_city']) {
				$erno[]=ucfirst($this->pi_getLL('delivery_city_is_required'));
			}
		}
		if (!$this->post['shipping_method'] && !$this->ms['MODULES']['PRODUCT_EDIT_METHOD_FILTER']) {
			// check to see if its allowed
			$str3="SELECT * from tx_multishop_payment_shipping_mappings where payment_method='".addslashes($this->post['payment_method'])."'";
			$qry3=$GLOBALS['TYPO3_DB']->sql_query($str3);
			if ($GLOBALS['TYPO3_DB']->sql_num_rows($qry3)>0) {
				$erno[]=$this->pi_getLL('no_shipping_method_chosen').'.';
			}
		}
		if (!$this->post['payment_method']) {
			$erno[]=$this->pi_getLL('no_payment_method_chosen').'.';
		}
		if ($this->ms['MODULES']['RIGHT_OF_WITHDRAWAL_CHECKBOX_IN_CHECKOUT'] && !$this->post['tx_multishop_pi1']['right_of_withdrawal']) {
			$erno[]=$this->pi_getLL('you_havent_accepted_the_right_of_withdrawal').'.';
		}
		if (!$this->post['accept_general_conditions']) {
			$erno[]=$this->pi_getLL('you_havent_accepted_the_general_conditions').'.';
		}
		// custom page hook that can be controlled by third-party plugin
		if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/scripts/front_pages/includes/checkout']['checkoutProcessValidateProc'])) {
			$params=array(
				'erno'=>&$erno,
				'mslib_cart'=>&$mslib_cart
			);
			foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/scripts/front_pages/includes/checkout']['checkoutProcessValidateProc'] as $funcRef) {
				\TYPO3\CMS\Core\Utility\GeneralUtility::callUserFunction($funcRef, $params, $this);
			}
		}
		// custom page hook that can be controlled by third-party plugin eof
		$user=array();
		$user['email']=$this->post['email'];
		$user['company']=$this->post['company'];
		$user['first_name']=$this->post['first_name'];
		$user['middle_name']=$this->post['middle_name'];
		$user['last_name']=$this->post['last_name'];
		if ($this->ms['MODULES']['CHECKOUT_ENABLE_BIRTHDAY']) {
			$user['birthday']=$this->post['birthday'];
		}
		$user['telephone']=$this->post['telephone'];
		$user['mobile']=$this->post['mobile'];
		$user['gender']=$this->post['gender'];
		$user['street_name']=$this->post['street_name'];
		$user['address_number']=$this->post['address_number'];
		$user['address_ext']=$this->post['address_ext'];
		$user['address']=$user['street_name'].' '.$user['address_number'].($user['address_ext'] ? '-'.$user['address_ext'] : '');
		$user['address']=preg_replace('/\s+/', ' ', $user['address']);
		$user['zip']=$this->post['zip'];
		$user['city']=$this->post['city'];
		$user['country']=$this->post['country'];
		$user['telephone']=$this->post['telephone'];
		$user['tx_multishop_newsletter']=$this->post['tx_multishop_newsletter'];
		if ($this->ms['MODULES']['CHECKOUT_ENABLE_STATE']) {
			$user['state']=$this->post['state'];
		}
		if ($this->ms['MODULES']['CHECKOUT_DISPLAY_VAT_ID_INPUT'] && !empty($this->post['tx_multishop_vat_id'])) {
			$user['tx_multishop_vat_id']=$this->post['tx_multishop_vat_id'];
		}
		if ($this->ms['MODULES']['CHECKOUT_DISPLAY_COC_ID_INPUT'] && !empty($this->post['tx_multishop_coc_id'])) {
			$user['tx_multishop_coc_id']=$this->post['tx_multishop_coc_id'];
		}
		// billing details eof
		// delivery details
		if (!$this->post['different_delivery_address']) {
			$user['different_delivery_address']=0;
		} else {
			$user['different_delivery_address']=1;
			$user['delivery_email']=$this->post['delivery_email'];
			$user['delivery_company']=$this->post['delivery_company'];
			$user['delivery_first_name']=$this->post['delivery_first_name'];
			$user['delivery_middle_name']=$this->post['delivery_middle_name'];
			$user['delivery_last_name']=$this->post['delivery_last_name'];
			$user['delivery_telephone']=$this->post['delivery_telephone'];
			$user['delivery_mobile']=$this->post['delivery_mobile'];
			$user['delivery_gender']=$this->post['delivery_gender'];
			$user['delivery_street_name']=$this->post['delivery_street_name'];
			$user['delivery_address_number']=$this->post['delivery_address_number'];
			$user['delivery_address_ext']=$this->post['delivery_address_ext'];
			$user['delivery_address']=$user['delivery_street_name'].' '.$user['delivery_address_number'].($user['delivery_address_ext'] ? '-'.$user['delivery_address_ext'] : '');
			$user['delivery_address']=preg_replace('/\s+/', ' ', $user['delivery_address']);
			$user['delivery_zip']=$this->post['delivery_zip'];
			$user['delivery_city']=$this->post['delivery_city'];
			$user['delivery_country']=$this->post['delivery_country'];
			$user['delivery_email']=$this->post['delivery_email'];
			$user['delivery_telephone']=$this->post['delivery_telephone'];
			$user['delivery_state']=$this->post['delivery_state'];
		}
		// delivery details eof
		if (!$erno) {
			$payment_method=mslib_fe::getPaymentMethod($this->post['payment_method']);
			if ($payment_method['handling_costs']) {
				if (!strstr($payment_method['handling_costs'], "%")) {
					$user['payment_method_costs']=$payment_method['handling_costs'];
				} else {
					// calculate total payment costs based by %
					$subtotal = $cart['summarize']['grand_total_excluding_vat'] - $cart['user']['payment_method_costs'];
					if ($subtotal) {
						if (strstr($payment_method['handling_costs'], "%")) {
							$percentage=str_replace("%", '', $payment_method['handling_costs']);
							$user['payment_method_costs']=($subtotal/100*$percentage);
						} else {
							$user['payment_method_costs']=$payment_method['handling_costs'];
						}
					}
				}
			} else {
				$user['payment_method_costs']=0;
			}
			if ($payment_method['tax_id'] && $user['payment_method_costs']) {
				$user['payment_total_tax_rate']=$payment_method['tax_rate'];
				if ($payment_method['country_tax_rate']) {
					$user['payment_country_tax_rate']=$payment_method['country_tax_rate'];
					$user['payment_country_tax']=mslib_fe::taxDecimalCrop($user['payment_method_costs']*($payment_method['country_tax_rate']));
				} else {
					$user['payment_country_tax_rate']=0;
					$user['payment_country_tax']=0;
				}
				if ($payment_method['region_tax_rate']) {
					$user['payment_region_tax_rate']=$payment_method['region_tax_rate'];
					$user['payment_region_tax']=mslib_fe::taxDecimalCrop($user['payment_method_costs']*($payment_method['region_tax_rate']));
				} else {
					$user['payment_region_tax_rate']=0;
					$user['payment_region_tax']=0;
				}
				if ($user['payment_region_tax'] && $user['payment_country_tax']) {
					$user['payment_tax']=$user['payment_country_tax']+$user['payment_region_tax'];
				} else {
					$user['payment_tax']=mslib_fe::taxDecimalCrop($user['payment_method_costs']*($payment_method['tax_rate']));
				}
			} else {
				$user['payment_tax']=0;
				$user['payment_country_tax']=0;
				$user['payment_region_tax']=0;
				$user['payment_total_tax_rate']=0;
				$user['payment_country_tax_rate']=0;
				$user['payment_region_tax_rate']=0;
			}
			$user['payment_method']=$payment_method['code'];
			$user['payment_method_label']=$payment_method['name'];
			$priceArray=mslib_fe::getShippingCosts($mslib_cart->getCountry(), $this->post['shipping_method']);
			$price=$priceArray['shipping_costs'];
			if ($price) {
				$user['shipping_method_costs']=$price;
			} else {
				$user['shipping_method_costs']=0;
			}
			$shipping_method=mslib_fe::getShippingMethod($this->post['shipping_method'], 's.id', $mslib_cart->getCountry());
			if ($shipping_method['tax_id'] && $user['shipping_method_costs']) {
				$user['shipping_total_tax_rate']=$shipping_method['tax_rate'];
				if ($shipping_method['country_tax_rate']) {
					$user['shipping_country_tax_rate']=$shipping_method['country_tax_rate'];
					$user['shipping_country_tax']=mslib_fe::taxDecimalCrop($user['shipping_method_costs']*($shipping_method['country_tax_rate']));
				} else {
					$user['shipping_country_tax_rate']=0;
					$user['shipping_country_tax']=0;
				}
				if ($shipping_method['region_tax_rate']) {
					$user['shipping_region_tax_rate']=$shipping_method['region_tax_rate'];
					$user['shipping_region_tax']=mslib_fe::taxDecimalCrop($user['shipping_method_costs']*($shipping_method['region_tax_rate']));
				} else {
					$user['shipping_region_tax_rate']=0;
					$user['shipping_region_tax']=0;
				}
				if ($user['shipping_region_tax'] && $user['shipping_country_tax']) {
					$user['shipping_tax']=$user['shipping_country_tax']+$user['shipping_region_tax'];
				} else {
					$user['shipping_tax']=mslib_fe::taxDecimalCrop($user['shipping_method_costs']*($shipping_method['tax_rate']));
				}
			} else {
				$user['shipping_tax']=0;
				$user['shipping_country_tax']=0;
				$user['shipping_region_tax']=0;
				$user['shipping_total_tax_rate']=0;
				$user['shipping_country_tax_rate']=0;
				$user['shipping_region_tax_rate']=0;
			}
			$user['shipping_method']=$shipping_method['code'];
			$user['shipping_method_label']=$shipping_method['name'];
			// custom hook that can be controlled by third-party plugin
			if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/scripts/front_pages/includes/checkout/multistep/checkout_address.php']['checkoutAddressUserSessionPreHook'])) {
				$params=array(
					'user'=>&$user
				);
				foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/scripts/front_pages/includes/checkout/multistep/checkout_address.php']['checkoutAddressUserSessionPreHook'] as $funcRef) {
					\TYPO3\CMS\Core\Utility\GeneralUtility::callUserFunction($funcRef, $params, $this);
				}
			}
			// custom hook that can be controlled by third-party plugin eof
			$cart['user']=$user;
			$GLOBALS['TSFE']->fe_user->setKey('ses', $this->cart_page_uid, $cart);
			$GLOBALS['TSFE']->storeSessionData();
			// good, proceed with the next step
			require_once(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::extPath('multishop').'pi1/classes/class.tx_mslib_order.php');
			$mslib_order=\TYPO3\CMS\Core\Utility\GeneralUtility::makeInstance('tx_mslib_order');
			$mslib_order->init($this);
			$orders_id=$mslib_cart->convertCartToOrder($GLOBALS['TSFE']->fe_user->getKey('ses', $this->cart_page_uid));
			if ($orders_id) {
				$show_thank_you=1;
				if ($show_thank_you) {
					// reload the order so all vars are the same
					$order=mslib_fe::getOrder($orders_id);
					$content.=CheckoutStepping($stepCodes, current($stepCodes), $this);
					// good, proceed to the thank you page
					$send_mail=1;
					if ($send_mail) {
						// replacing the variables with dynamic values eof
						//						$user=array();
						//						$user['name']	= $full_customer_name;
						//						$user['email']	= $address['email'];
						mslib_fe::mailOrder($orders_id, 1);
					}
					$order=$GLOBALS['TSFE']->fe_user->getKey('ses', 'tx_multishop_order');
					$order['orders_id']=$orders_id;
					$GLOBALS['TSFE']->fe_user->setKey('ses', 'tx_multishop_order', $order);
					$GLOBALS['TSFE']->storeSessionData();
					next($stepCodes);
					header("Location: ".$this->FULL_HTTP_URL.mslib_fe::typolink($this->conf['checkout_page_pid'], '&tx_multishop_pi1[page_section]='.$this->ms['page'].'&tx_multishop_pi1[previous_checkout_section]='.current($stepCodes).'&orders_id='.$orders_id));
					exit();
					//			include(current($stepCodes).'.php');
				}
			}
		}
	} else {
		$show_checkout_address=1;
	}
	if ($erno or $show_checkout_address) {
		// load enabled countries to array
		$str2="SELECT * from static_countries sc, tx_multishop_countries_to_zones c2z, tx_multishop_shipping_countries c where c.page_uid='".$this->showCatalogFromPage."' and sc.cn_iso_nr=c.cn_iso_nr and c2z.cn_iso_nr=sc.cn_iso_nr group by c.cn_iso_nr order by sc.cn_short_en";
		$qry2=$GLOBALS['TYPO3_DB']->sql_query($str2);
		$enabled_countries=array();
		while ($row2=$GLOBALS['TYPO3_DB']->sql_fetch_assoc($qry2)) {
			$enabled_countries[]=$row2;
		}
		// load enabled countries to array eof
		$regex='/^[-a-z0-9~!$%^&*_=+}{\'?]+(\.[-a-z0-9~!$%^&*_=+}{\'?]+)*@([a-z0-9_][-a-z0-9_]*(\.[-a-z0-9_]+)*\.(aero|arpa|biz|com|coop|edu|gov|info|int|mil|museum|name|net|org|pro|travel|mobi|[a-z][a-z])|([0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}))(:[0-9]{1,5})?$/i';
		$regex_for_character="/[^0-9]$/";
		if ($this->ms['MODULES']['CHECKOUT_VALIDATE_FORM']) {
			$GLOBALS['TSFE']->additionalHeaderData[]='
			<script type="text/javascript" src="typo3conf/ext/multishop/js/jquery.h5validate.js"></script>
			<script type="text/javascript">
				function validateMatches(value, $el, settings) {
    				var matchEl = \'#\' + $el.attr(\'data-h5-matches\'),
        			match = jQuery(matchEl).val();
    				return value == match;
				}
				jQuery(document).ready(function () {
    				// custom method for email confirmation field (not good)
					//jQuery.h5Validate.addMethods({
        			//	\'matches\': validateMatches
    				//});

					jQuery(\'#onestep_checkout\').h5Validate();
				});
				jQuery(function(){
					// init
					// hide shipping when no country selected
					var form_prefilled = true;
					var payment_pre_selected_id = 0;
					if (jQuery(\'#checkboxdifferent_delivery_address\').is(\':checked\')) {
						if (jQuery(\'#delivery_country\').val() == \'\') {
							form_prefilled = false;
						}

					} else {
						if (jQuery(\'#country\').val() == \'\') {
							form_prefilled = false;
						}
					}
					var getPaymentMethods = function (billing_country, delivery_country) {
						// fetch available payment methods for selected user country
						if (billing_country!=\'\') {
							jQuery.ajax({
								url: \'' . mslib_fe::typolink('', '&type=2002&tx_multishop_pi1[page_section]=get_country_payment_methods') . '\',
								data: \'b_cc=\' + billing_country + \'&d_cc=\' + delivery_country,
								type: \'post\',
								dataType: \'json\',
								success: function (j){
									if (j) {
										var json_data = j;
										var li_data = \'\';
										var i_ctr = 0;
										//jQuery(\'.multishopPaymentMethodWrapper .content\').empty();
										jQuery.each(json_data, function(i, obj) {
											//jQuery(obj).each(function() {
												li_data += \'<li class="\' + obj.li_class + \' col-sm-12" id="multishop_payment_method_\' + obj.payment_id + \'">\';
												li_data += \'<div class="listing_item">\';
												if (obj.handling_cost!="") {
													li_data += \'<div class="payment_costs" style="float:right"><strong>\' + obj.handling_cost + \'</strong></div>\';
												}
												li_data += \'<div class="radio radio-success radio-inline">\';
												if (i_ctr > 0) {
													li_data += \'<input name="payment_method" id="payment_method_\' + obj.payment_id + \'" type="radio" value="\' + obj.payment_id + \'">\';
												} else {
													payment_pre_selected_id = obj.payment_id;
													li_data += \'<input name="payment_method" id="payment_method_\' + obj.payment_id + \'" type="radio" value="\' + obj.payment_id + \'" checked="checked">\';
												}
												li_data += \'<label for="payment_method_\' + obj.payment_id + \'" class="name"><strong>\' + obj.payment_label + \' </strong></label>\';
												li_data += \'</div>\';
												//li_data += \'<strong>\' + obj.payment_label + \' </strong>\';
												li_data += \'<div class="description">\' + obj.payment_description + \'</div>\';
												li_data += \'</div></li>\';
												i_ctr++;
											//});
										});
										//jQuery(\'.multishopPaymentMethodWrapper .content\').empty();
										//jQuery(\'.multishopPaymentMethodWrapper .content\').append(\'<ul id="multishopPaymentMethod" class="row">\' + li_data + \'</ul>\');
										jQuery(\'#multishopPaymentMethod\').empty();
										jQuery(\'#multishopPaymentMethod\').append(li_data);
										getMethodCost(billing_country, delivery_country, 0, payment_pre_selected_id);
									}
								}
							});
						}
					}
					var getMethodCost = function (billing_country, delivery_country, shipping_id, payment_id) {
						// lets do some shipping + payment cost fetching
						var vat_id=\'\';
						if (jQuery(\'#tx_multishop_vat_id\').length>0 && jQuery(\'#tx_multishop_vat_id\').val()!=\'\') {
							vat_id=\'&tx_multishop_vat_id=\' + jQuery(\'#tx_multishop_vat_id\').val();
						}
						jQuery.ajax({
							url: \''.mslib_fe::typolink('', '&type=2002&tx_multishop_pi1[page_section]=get_method_costs').'\',
							data: \'b_cc=\' + billing_country + \'&d_cc=\' + delivery_country + \'&tx_multishop_pi1[sid]=\' + shipping_id + \'&tx_multishop_pi1[pid]=\' + payment_id + vat_id,
							type: \'post\',
							dataType: \'json\',
							success: function (j) {
								if (j) {
									var shipping_name = j.shipping_name;
									var payment_name = j.payment_name;
									var available_sc = j.available_shippingcost;
									var available_sid = j.available_shipping.split(\';\');
							  		if (available_sid != \'\') {
										jQuery(\'.multishopShippingMethodWrapper\').show();
										jQuery(\'#multishopShippingMethod\').find(\'li\').each(function() {
											jQuery(\'#\' + this.id).hide();
										});
										if (available_sid.length > 0) {
											var ctr = 1;
											jQuery.each(available_sid, function(index, val) {
												var sm_id = \'#shipping_method_\' + val;
												var msm_id = \'#multishop_shipping_method_\' + val;
												jQuery(msm_id + \' .shipping_price\').empty();
												jQuery(msm_id + \' .shipping_price\').append(available_sc[val]);
												jQuery(msm_id).show();
												if (ctr == 1 && available_sid.length == 1) {
													jQuery(sm_id).attr(\'checked\', true);
												}
												ctr++;
											});
										} else {
											jQuery(\'#multishop_shipping_method_1\').show();
											jQuery(\'#shipping_method_1\').attr(\'checked\', true);
											//jQuery(\'#shipping_method_1\').button(\'refresh\');
										}
									} else {
										jQuery(\'.multishopShippingMethodWrapper\').hide();
									}
									// display cart contents
									$("#msFrontCartContentsWrapper").html(j.htmlCartContents);
								}
							}
						});
					}
					if (form_prefilled) {
						var shipping_id	= 0;
						var payment_id	= 0;
						var b_country		= jQuery(\'#country\').val();
						if (jQuery(\'#checkboxdifferent_delivery_address\').is(\':checked\')) {
							var d_country		= jQuery(\'#delivery_country\').val();
						} else {
							var d_country		= jQuery(\'#country\').val();
						}
						// find which payment method are selected
						jQuery(\'#multishopPaymentMethod\').find(\':input\').each(function() {
							if (this.type == \'radio\') {
								if (this.checked == true) {
									payment_id = this.value;
								}
							}
						});
						// find which shipping method are selected
						jQuery(\'#multishopShippingMethod\').find(\':input\').each(function() {
							if (this.type == \'radio\') {
								if (this.checked == true) {
									shipping_id = this.value;
								}
							}
						});
						getPaymentMethods(b_country, d_country);
						setTimeout(function(){
							getMethodCost(b_country, d_country, shipping_id, payment_id);
						}, 1000);

					}
					// update payment cost when payment method changes
					jQuery(document).on(\'click\',\'#multishopPaymentMethod :input:radio\',function() {
						var shipping_id	= 0;
						var payment_id	= jQuery(this).val();
						var b_country	= jQuery(\'#country\').val();
						if (jQuery(\'#checkboxdifferent_delivery_address\').is(\':checked\')) {
							var d_country		= jQuery(\'#delivery_country\').val();
						} else {
							var d_country		= jQuery(\'#country\').val();
						}
						// find which shipping method are selected
						jQuery(\'#multishopShippingMethod :input:radio\').each(function() {
							if (this.checked == true) {
								shipping_id = this.value;
							}
						});
						getMethodCost(b_country, d_country, shipping_id, payment_id);
					});
					// end of update payment cost when payment method changes
					// update shipping cost when shipping method changes
					jQuery(\'#multishopShippingMethod\').find(\':input:radio\').bind("click", function() {
						var shipping_id	= jQuery(this).val();
						var payment_id	= 0;
						var b_country = jQuery(\'#country\').val();
						if (jQuery(\'#checkboxdifferent_delivery_address\').is(\':checked\')) {
							var d_country		= jQuery(\'#delivery_country\').val();
						} else {
							var d_country		= jQuery(\'#country\').val();
						}
						// find which shipping method are selected
						jQuery(\'#multishopPaymentMethod\').find(\':input\').each(function() {
							if (this.type == \'radio\') {
								if (this.checked == true) {
									payment_id = this.value;
								}
							}
						});
						getMethodCost(b_country, d_country, shipping_id, payment_id);
					});
					// end of update shipping cost when shipping method changes
					// update shipping/payment cost when customer country selected
					jQuery("#delivery_country").bind("change",function(){
						var shipping_id	= 0;
						var payment_id	= 0;
						var b_country = jQuery(\'#country\').val();
						var d_country	= jQuery(this).val();
						// find which shipping method are selected
						jQuery(\'#multishopShippingMethod\').find(\':input\').each(function() {
							if (this.type == \'radio\') {
								if (this.checked == true) {
									shipping_id = this.value;
								}
							}
						});
						// find which payment method are selected
						jQuery(\'#multishopPaymentMethod :input\').each(function() {
							if (this.type == \'radio\') {
								if (this.checked == true) {
									payment_id = this.value;
								}
							}
						});
						if (jQuery("#checkboxdifferent_delivery_address").is(\':checked\')){
							getMethodCost(b_country, d_country, shipping_id, payment_id);
						}
					});
					'.($this->ms['MODULES']['CHECKOUT_DISPLAY_VAT_ID_INPUT'] ? '
					jQuery(document).on(\'change paste\',\'#tx_multishop_vat_id\',function(){
						var shipping_id= 0;
						var payment_id= 0;
						var b_country=jQuery(\'#country\').val();
						if (jQuery(\'#checkboxdifferent_delivery_address\').is(\':checked\')) {
							var d_country=jQuery(\'#delivery_country\').val();
						} else {
							var d_country=jQuery(\'#country\').val();
						}
						// find which shipping method are selected
						jQuery(\'#multishopShippingMethod :input\').each(function() {
							if (this.type == \'radio\') {
								if (this.checked == true) {
									shipping_id = this.value;
								}
							}
						});
						// find which payment method are selected
						jQuery(\'#multishopPaymentMethod :input\').each(function() {
							if (this.type == \'radio\') {
								if (this.checked == true) {
									payment_id = this.value;
								}
							}
						});
						// fetch payment methods available for selected user country
						getPaymentMethods(b_country, d_country);
						getMethodCost(b_country, d_country, shipping_id, payment_id);
					});
					' : '').'
					jQuery(document).on(\'change\',\'#country\',function(){
						var shipping_id	= 0;
						var payment_id	= 0;
						var b_country		= jQuery(this).val();
						if (jQuery(\'#checkboxdifferent_delivery_address\').is(\':checked\')) {
							var d_country=jQuery(\'#delivery_country\').val();
						} else {
							var d_country=jQuery(\'#country\').val();
						}
						// fetch payment methods available for selected user country
						getPaymentMethods(b_country, d_country);
						// find which shipping method are selected
						jQuery(\'#multishopShippingMethod :input\').each(function() {
							if (this.type == \'radio\') {
								if (this.checked == true) {
									shipping_id = this.value;
								}
							}
						});
						// find which payment method are selected
						jQuery(\'#multishopPaymentMethod :input\').each(function() {
							if (this.type == \'radio\') {
								if ($(this).is(\':checked\')) {
									payment_id = this.value;
								}
							}
						});
						if (payment_id==0 && payment_pre_selected_id>0) {
							payment_id=payment_pre_selected_id;
						}
						getMethodCost(b_country, d_country, shipping_id, payment_id);
					});
					 // end of update shipping.payment cost when customer country selected
					 /*jQuery("#company").change(function() {
					 	if (jQuery("#company").val() != "") {
							jQuery("#multishopPaymentMethod_5").hide();
							jQuery("#multishopPaymentMethod_6").hide();
						} else {
							jQuery("#multishopPaymentMethod_5").show();
							jQuery("#multishopPaymentMethod_6").show();
						}
					 });*/
					 jQuery("#submit").bind("click", function() {
					 	jQuery("body").scrollTop(0);
					 });
				});
			</script>';
			$GLOBALS['TSFE']->additionalHeaderData[]=$validation;
		}
		// birthday validation
		if ($this->ms['MODULES']['CHECKOUT_ENABLE_BIRTHDAY']) {
			$GLOBALS['TSFE']->additionalHeaderData[]='
		<script type="text/javascript">
			jQuery().ready(function(){
				jQuery("#birthday").datepicker({
					dateFormat: "dd-mm-yy",
					changeMonth: true,
					changeYear: true,
					showOtherMonths: true,
					yearRange: "'.(date("Y")-100).':'.date("Y").'"
				});
				jQuery("#birthday").bind("blur",function(){
						jQuery(this).next().removeClass("error-no");
				});
			});
		 </script>';
		}
		// birthday validation eof
		// now parse all the objects in the tmpl file
		if ($this->conf['checkout_address_tmpl']) {
			$template=$this->cObj->fileResource($this->conf['checkout_address_tmpl']);
		} else {
			$template=$this->cObj->fileResource(\TYPO3\CMS\Core\Utility\ExtensionManagementUtility::siteRelPath('multishop_one_step_checkout').'templates/checkout_address.tmpl');
		}
		// Extract the subparts from the template
		$subparts=array();
		$subparts['template']=$this->cObj->getSubpart($template, '###TEMPLATE###');
		$subparts['newsletter_optin']=$this->cObj->getSubpart($subparts['template'], '###NEWSLETTER_OPTIN###');
		$error_block='';
		if (is_array($erno) and count($erno)>0) {
			// php errors
			$error_block.='<div class="error_msg">';
			$error_block.='<h3>'.$this->pi_getLL('the_following_errors_occurred').'</h3><ul class="ul-display-error">';
			foreach ($erno as $item) {
				$error_block.='<li>'.$item.'</li>';
			}
			$error_block.='</ul>';
			$error_block.='</div>';
		} else {
			// no php errors, just print container for js
			$error_block.='<div class="error_msg" style="display:none">';
			$error_block.='<h3>'.$this->pi_getLL('the_following_errors_occurred').'</h3><ul class="ul-display-error">';
			$error_block.='<li class="item-error" style="display:none"></li>';
			$error_block.='</ul></div>';
		}
		$birtdate_block='';
		if ($this->ms['MODULES']['CHECKOUT_ENABLE_BIRTHDAY']) {
			$birtdate_block.='<div class="account-field col-sm-12" id="input-dob">
					<label for="birthday" id="account-birthday">'.ucfirst($this->pi_getLL('birthday')).'</label>
					<input type="text" name="birthday" class="birthday" id="birthday" value="'.htmlspecialchars($user['birthday']).'" >
					</div>';
		}
		$state_block='';
		if ($this->ms['MODULES']['CHECKOUT_ENABLE_STATE']) {
			$state_block.='<div class="account-field col-sm-12" id="input-state">
			<label class="account-state" for="state">'.ucfirst($this->pi_getLL('state')).'<span class="text-danger">*</span></label>
			<input type="text" name="state" id="state" class="state" value="'.htmlspecialchars($user['state']).'" >
			</div>';
		}
		// load countries
		$country_block='';
		if (count($enabled_countries)==1) {
			$country_block.='<input name="country" id="country" type="hidden" value="'.strtolower($enabled_countries[0]['cn_short_en']).'" />';
			$country_block.='<input name="delivery_country" id="delivery_country" type="hidden" value="'.strtolower($enabled_countries[0]['cn_short_en']).'" />';
		} else {
			$default_country=mslib_fe::getCountryByIso($this->ms['MODULES']['COUNTRY_ISO_NR']);
			if (!$user['country']) {
				$user['country']=$default_country['cn_short_en'];
			}
			if (!$user['delivery_country']) {
				$user['delivery_country']=$default_country['cn_short_en'];
			}
			foreach ($enabled_countries as $country) {
				$tmpcontent_con.='<option value="'.strtolower($country['cn_short_en']).'" '.((strtolower($user['country'])==strtolower($country['cn_short_en'])) ? 'selected' : '').'>'.htmlspecialchars(mslib_fe::getTranslatedCountryNameByEnglishName($this->lang, $country['cn_short_en'])).'</option>';
				$tmpcontent_con_delivery.='<option value="'.strtolower($country['cn_short_en']).'" '.((strtolower($user['delivery_country'])==strtolower($country['cn_short_en'])) ? 'selected' : '').'>'.htmlspecialchars(mslib_fe::getTranslatedCountryNameByEnglishName($this->lang, $country['cn_short_en'])).'</option>';
			}
			if ($tmpcontent_con) {
				$country_block.='
				<div class="account-field col-sm-' . ($this->conf['checkout_address_tmpl'] ? '12' : '6') . '" id="input-country">
				<label for="country" id="account-country">'.ucfirst($this->pi_getLL('country')).'<span class="text-danger">*</span></label>
				<select name="country" id="country" class="country" required="required" data-h5-errorid="invalid-country" title="'.$this->pi_getLL('country_is_required').'">
				<option value="">'.ucfirst($this->pi_getLL('choose_country')).'</option>
				'.$tmpcontent_con.'
				</select>
				<div id="invalid-country" class="error-space" style="display:none"></div>
		        </div>';
			}
		}
		// country eof
		$state_delivery_block='';
		if ($this->ms['MODULES']['CHECKOUT_ENABLE_STATE']) {
			$state_delivery_block.='<div class="account-field col-sm-12" id="input-dfstate">
			<label class="account-state" for="delivery_state">'.ucfirst($this->pi_getLL('state')).'<span class="text-danger">*</span></label>
			<input type="text" name="delivery_state" id="delivery_state" class="delivery_state" value="'.htmlspecialchars($user['delivery_state']).'" ><span class="error-space left-this"></span>
			</div>';
		}
		$delivery_country_block='';
		if ($tmpcontent_con) {
			$delivery_country_block.='
			<div class="account-field col-sm-' . ($this->conf['checkout_address_tmpl'] ? '12' : '6') . '" id="input-dfcountry">
			<label for="delivery_country" id="account-country">'.ucfirst($this->pi_getLL('country')).'<span class="text-danger">*</span></label>
			<select name="delivery_country" id="delivery_country" class="delivery_country">
			<option value="">'.ucfirst($this->pi_getLL('choose_country')).'</option>
			'.$tmpcontent_con_delivery.'
			</select>
			<div id="invalid-delivery_country" class="error-space" style="display:none"></div>
			</div>
			';
		}
		$payment_method_block='';
		$count=0;
		$tr_type='even';
		$countries_id=$mslib_cart->getCountry();
		foreach ($payment_methods as $code=>$item) {
			// custom hook that can be controlled by third-party plugin
			$payment_method_description='';
			if (!empty($item['description'])) {
				$payment_method_description='<div class="description">'.$item['description'].'</div>';
			}
			if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop_one_step_checkout/res/one_step_checkout/checkout_address.php']['checkoutOnestepPaymentMethodSelectionHook'])) {
				$params=array(
					'item'=>&$item,
					'payment_method_description'=>&$payment_method_description,
				);
				foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop_one_step_checkout/res/one_step_checkout/checkout_address.php']['checkoutOnestepPaymentMethodSelectionHook'] as $funcRef) {
					\TYPO3\CMS\Core\Utility\GeneralUtility::callUserFunction($funcRef, $params, $this);
				}
			}
			// custom hook that can be controlled by third-party plugin eof
			$payment_method=mslib_fe::getPaymentMethod($code, 'p.code', $countries_id);
			$vars=unserialize($payment_method['vars']);
			if (!$tr_type or $tr_type=='even') {
				$tr_type='odd';
			} else {
				$tr_type='even';
			}
			$count++;
			// costs
			$price_wrap='';
			$price=$item['handling_costs'];
			if ($price>0) {
				if ($vars['handling_costs_type']!='percentage') {
					if ($price and $payment_method['tax_rate']>0) {
						$price=($price*$payment_method['tax_rate'])+$price;
					}
					$price=mslib_fe::amount2Cents($price);
				}
				$price_wrap='<div class="shipping_price" style="float:right"><strong>'.$price.'</strong></div>';
			}
			// costs eof
			$payment_method_block.='<li class="'.$tr_type.' col-sm-12"  id="multishop_payment_method_'.$item['id'].'">
			<div class="listing_item">
			';
			if ($price_wrap) {
				$payment_method_block.=$price_wrap;
			}
			$payment_method_block.='<div class="radio radio-success radio-inline">';
			$payment_method_block.='<input name="payment_method" id="payment_method_'.$item['id'].'" type="radio" value="'.htmlspecialchars($item['id']).'" '.(($this->post['tx_multishop_pi1[previous_checkout_section]']<>current($stepCodes) and $count==1) ? 'checked' : '').' /><label for="payment_method_'.$item['id'].'" class="name"><strong>'.$item['name'].'</strong></label></div>';
			$payment_method_block.=$payment_method_description;
			$payment_method_block.='</div></li>';
			//Lorum da ipsilon da riski. Lorum da ipsilon da riski. Lorum da ipsilon da riski. Lorum da ipsilon da riski.
		}
		$shipping_method_block='';
		$count=0;
		foreach ($shipping_methods as $code=>$item) {
			// custom hook that can be controlled by third-party plugin
			$shipping_method_description='';
			if (!empty($item['description'])) {
				$shipping_method_description='<div class="description">'.$item['description'].'</div>';
			}
			if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop_one_step_checkout/res/one_step_checkout/checkout_address.php']['checkoutOnestepShippingMethodSelectionHook'])) {
				$params=array(
					'item'=>&$item,
					'shipping_method_description'=>&$shipping_method_description,
				);
				foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop_one_step_checkout/res/one_step_checkout/checkout_address.php']['checkoutOnestepShippingMethodSelectionHook'] as $funcRef) {
					\TYPO3\CMS\Core\Utility\GeneralUtility::callUserFunction($funcRef, $params, $this);
				}
			}
			// custom hook that can be controlled by third-party plugin eof
			$count++;
			// costs
			$price_wrap='';
			$priceArray=mslib_fe::getShippingCosts($cart['user']['countries_id'], $item['id']);
			if ($priceArray['shipping_costs_including_vat']>0) {
				$price=mslib_fe::amount2Cents($priceArray['shipping_costs_including_vat']);
				$price_wrap='<div class="shipping_price" style="float:right">'.$price.'</div>';
			}
			// costs eof
			$shipping_method_block.='<li class="col-sm-12" id="multishop_shipping_method_'.$item['id'].'">';
			$shipping_method_block.='<div class="listing_item">';
			if ($price_wrap) {
				$shipping_method_block.=$price_wrap;
			}
			$shipping_method_block.='<div class="radio radio-success radio-inline">';
			$shipping_method_block.='<input name="shipping_method" id="shipping_method_'.$item['id'].'" type="radio" value="'.htmlspecialchars($item['id']).'" '.(($this->post['tx_multishop_pi1[previous_checkout_section]']<>current($stepCodes) and $count==1) ? 'checked' : '').' /><label for="shipping_method_'.$item['id'].'" class="name"><strong>'.$item['name'].'</strong></label></div>';
			$shipping_method_block.=$shipping_method_description;
			$shipping_method_block.='</div></li>';
		}
		$general_condition_label=$this->pi_getLL('click_here_if_you_agree_the_general_conditions');
		$page=mslib_fe::getCMScontent('general_conditions', $GLOBALS['TSFE']->sys_language_uid);
		if ($page[0]['content']) {
			$general_condition_label.=' (<a href="'.mslib_fe::typolink($this->shop_pid, '&tx_multishop_pi1[page_section]=info&tx_multishop_pi1[cms_hash]='.$page[0]['hash']).'" target="_blank" class="read_general_conditions">'.$this->pi_getLL('view_general_conditions').'</a>)';
		}
		$vat_input_block='';
		if ($this->ms['MODULES']['CHECKOUT_DISPLAY_VAT_ID_INPUT']) {
			$vat_input_block='
			<div class="account-field col-sm-6" id="input-vat">
			<label for="tx_multishop_vat_id" id="account-tx_multishop_vat_id">'.ucfirst($this->pi_getLL('vat_id')).'</label>
			<input type="text" name="tx_multishop_vat_id" class="tx_multishop_vat_id" id="tx_multishop_vat_id" value="'.htmlspecialchars($user['tx_multishop_vat_id']).'"/>
			</div>
			';
		}
		$coc_input_block='';
		if ($this->ms['MODULES']['CHECKOUT_DISPLAY_COC_ID_INPUT']) {
			$coc_input_block='<div class="account-field col-sm-6" id="input-coc"><label for="tx_multishop_coc_id" id="account-tx_multishop_coc_id">'.ucfirst($this->pi_getLL('coc_id')).'</label>
			<input type="text" name="tx_multishop_coc_id" class="tx_multishop_coc_id" id="tx_multishop_coc_id" value="'.htmlspecialchars($user['tx_multishop_coc_id']).'"/>
			</div>
			';
		}
		/*
		 * layout page
		*/
		$subpartArray=array();
		$subpartArray['###GENERAL_CONDITIONS_LABEL###']='';
		$subpartArray['###GENERAL_CONDITIONS_LINK###']='';
		if ($page[0]['content']) {
			$subpartArray['###GENERAL_CONDITIONS_LABEL###']=$this->pi_getLL('click_here_if_you_agree_the_general_conditions');
			$subpartArray['###GENERAL_CONDITIONS_LINK###']=mslib_fe::typolink($this->shop_pid, '&tx_multishop_pi1[page_section]=info&tx_multishop_pi1[cms_hash]='.$page[0]['hash']);
		}
		$subpartArray['###ERROR_DISPLAYER###']=$error_block;
		$subpartArray['###FORM_ACTION_LINK###']=mslib_fe::typolink('', '&tx_multishop_pi1[page_section]='.$this->ms['page'].'&tx_multishop_pi1[previous_checkout_section]='.current($stepCodes));
		$subpartArray['###LABEL_BILLING_ADDRESS###']=$this->pi_getLL('billing_address');
		$subpartArray['###LABEL_GENDER_TITLE###']=ucfirst($this->pi_getLL('title'));
		if ($this->ms['MODULES']['GENDER_INPUT_REQUIRED']) {
			$subpartArray['###GENDER_INPUT_REQUIRED###']='required="required" data-h5-errorid="invalid-gender"';
			$subpartArray['###INVALID_GENDER_MESSAGE###']='title="'.$this->pi_getLL('gender_is_required', 'Title is required').'"';
		} else {
			$subpartArray['###GENDER_INPUT_REQUIRED###']='';
			$subpartArray['###INVALID_GENDER_MESSAGE###']='';
		}
		$subpartArray['###VALUE_GENDER_MALE_CHECKED###']=(($user['gender']!='f') ? 'checked' : '');
		$subpartArray['###LABEL_GENDER_MALE###']=ucfirst($this->pi_getLL('mr'));
		$subpartArray['###VALUE_GENDER_FEMALE_CHECKED###']=(($user['gender']=='f') ? 'checked' : '');
		$subpartArray['###LABEL_GENDER_FEMALE###']=ucfirst($this->pi_getLL('mrs'));
		$subpartArray['###BIRTHDATE_BLOCK###']=$birtdate_block;
		$subpartArray['###LABEL_COMPANY###']=ucfirst($this->pi_getLL('company')).($this->ms['MODULES']['CHECKOUT_REQUIRED_COMPANY'] ? '<span class="text-danger">*</span>' : '');
		$subpartArray['###VALUE_COMPANY###']=htmlspecialchars($user['company']);
		$subpartArray['###INPUT_VAT_ID###']=$vat_input_block;
		$subpartArray['###INPUT_COC_ID###']=$coc_input_block;
		$subpartArray['###LABEL_FIRST_NAME###']=ucfirst($this->pi_getLL('first_name')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_FIRST_NAME###']=htmlspecialchars($user['first_name']);
		$subpartArray['###LABEL_MIDDLE_NAME###']=ucfirst($this->pi_getLL('middle_name'));
		$subpartArray['###VALUE_MIDDLE_NAME###']=htmlspecialchars($user['middle_name']);


		$subpartArray['###LABEL_FULL_NAME###']=ucfirst($this->pi_getLL('full_name'));
		$subpartArray['###VALUE_FULL_NAME###']='';
		if ($user['name']) {
			$subpartArray['###VALUE_FULL_NAME###']=htmlspecialchars($user['name']);
		} else {
			$array=array();
			if ($user['first_name']) {
				$array[]=$user['first_name'];
			}
			if ($user['middle_name']) {
				$array[]=$user['middle_name'];
			}
			if ($user['last_name']) {
				$array[]=$user['last_name'];
			}
			if (count($array)) {
				$subpartArray['###VALUE_FULL_NAME###']=htmlspecialchars(implode(' ',$array));
			}
		}

		$subpartArray['###LABEL_LAST_NAME###']=ucfirst($this->pi_getLL('last_name')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_LAST_NAME###']=htmlspecialchars($user['last_name']);
		$subpartArray['###LABEL_STREET_NAME###']=ucfirst($this->pi_getLL('street_address')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_STREET_NAME###']=htmlspecialchars($user['street_name']);
		$subpartArray['###LABEL_ADDRESS_NUMBER###']=ucfirst($this->pi_getLL('street_address_number')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_ADDRESS_NUMBER###']=htmlspecialchars($user['address_number']);
		$subpartArray['###LABEL_ADDRESS_EXT###']=ucfirst($this->pi_getLL('address_extension'));
		$subpartArray['###VALUE_ADDRESS_EXT###']=htmlspecialchars($user['address_ext']);


		$subpartArray['###LABEL_COUNTRY###']=ucfirst($this->pi_getLL('country'));
		$subpartArray['###VALUE_COUNTRY###']=htmlspecialchars(mslib_fe::getTranslatedCountryNameByEnglishName($this->lang, $user['country']));
		$subpartArray['###HIDDEN_VALUE_COUNTRY###']=$user['country'];

		$subpartArray['###LABEL_FULL_ADDRESS###']=ucfirst($this->pi_getLL('address'));
		$subpartArray['###VALUE_FULL_ADDRESS###']='';
		if ($user['address']) {
			$subpartArray['###VALUE_FULL_ADDRESS###']=htmlspecialchars($user['address']);
		} else {
			$array=array();
			if ($user['street_name']) {
				$array[]=$user['street_name'];
			}
			$addressNumber=array();
			if ($user['address_number']) {
				$addressNumber[]=$user['address_number'];
			}
			if ($user['address_ext']) {
				$addressNumber[]=$user['address_ext'];
			}
			if (count($addressNumber)) {
				$array[]=implode('-',$addressNumber);
			}
			if (count($array)) {
				$subpartArray['###VALUE_FULL_ADDRESS###']=htmlspecialchars(implode(' ',$array));
			}
		}

		$subpartArray['###VALUE_FULL_NAME###']=htmlspecialchars(implode(' ',$array));
		$subpartArray['###LABEL_POSTCODE###']=ucfirst($this->pi_getLL('zip')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_POSTCODE###']=htmlspecialchars($user['zip']);
		$subpartArray['###LABEL_CITY###']=ucfirst($this->pi_getLL('city')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_CITY###']=htmlspecialchars($user['city']);
		$subpartArray['###STATE_BLOCK###']=$state_block;
		$subpartArray['###COUNTRY_BLOCK###']=$country_block;
		$subpartArray['###LABEL_EMAIL###']=ucfirst($this->pi_getLL('e-mail_address')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_EMAIL###']=htmlspecialchars($user['email']);
		$subpartArray['###LABEL_CONFIRMATION_EMAIL###']=ucfirst($this->pi_getLL('verify_email_address')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_CONFIRMATION_EMAIL###']=htmlspecialchars($user['email']);
		$subpartArray['###LABEL_TELEPHONE_NUMBER###']=ucfirst($this->pi_getLL('telephone')).($this->ms['MODULES']['CHECKOUT_REQUIRED_TELEPHONE']=='1' ? '<span class="text-danger">*</span>' : '');
		$subpartArray['###VALUE_TELEPHONE_NUMBER###']=htmlspecialchars($user['telephone']);
		$subpartArray['###DIFFERENT_DELIVERY_ADDRESS_CHECKED###']=(($user['different_delivery_address']) ? 'checked' : '');
		$subpartArray['###LABEL_DIFFERENT_DELIVERY_ADDRESS###']=$this->pi_getLL('click_here_if_your_delivery_address_is_different_from_your_billing_address');
		$subpartArray['###JS_DELIVERY_BIRTDAY_REMOVE_CLASS_LEFT_THIS0###']=($this->ms['MODULES']['CHECKOUT_ENABLE_BIRTHDAY'] ? 'jQuery("#delivery_birthday").next().removeClass("left-this");' : '');
		$subpartArray['###JS_DELIVERY_BIRTDAY_REMOVE_CLASS_LEFT_THIS1###']=($this->ms['MODULES']['CHECKOUT_ENABLE_BIRTHDAY'] ? 'jQuery("#delivery_birthday").next().removeClass("left-this");' : '');
		$subpartArray['###JS_DELIVERY_BIRTDAY_REMOVE_CLASS_ERROR_NO###']=($this->ms['MODULES']['CHECKOUT_ENABLE_BIRTHDAY'] ? 'jQuery("#delivery_birthday").next().removeClass("error-no");' : '');
		$subpartArray['###JS_DELIVERY_BIRTDAY_REMOVE###']=($this->ms['MODULES']['CHECKOUT_ENABLE_BIRTHDAY'] ? 'jQuery(".ul-display-error").find(".delivery_birthday").remove();' : '');
		$subpartArray['###LABEL_DELIVERY_GENDER###']=ucfirst($this->pi_getLL('title'));
		$subpartArray['###DELIVERY_GENDER_MALE_CHECKED###']=(($user['delivery_gender']=='m') ? 'checked' : '');
		$subpartArray['###LABEL_DELIVERY_GENDER_MALE###']=ucfirst($this->pi_getLL('mr'));
		$subpartArray['###DELIVERY_GENDER_FEMALE_CHECKED###']=(($user['delivery_gender']=='f') ? 'checked' : '');
		$subpartArray['###LABEL_DELIVERY_GENDER_FEMALE###']=ucfirst($this->pi_getLL('mrs'));
		$subpartArray['###LABEL_COMPANY_NAME###']=ucfirst($this->pi_getLL('company')).($this->ms['MODULES']['CHECKOUT_REQUIRED_COMPANY'] ? '<span class="text-danger">*</span>' : '').':';
		$subpartArray['###VALUE_COMPANY_NAME###']=htmlspecialchars($user['delivery_company']);
		$subpartArray['###LABEL_DELIVERY_FIRST_NAME###']=ucfirst($this->pi_getLL('first_name')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_DELIVERY_FIRST_NAME###']=htmlspecialchars($user['delivery_first_name']);
		$subpartArray['###LABEL_DELIVERY_MIDDLE_NAME###']=ucfirst($this->pi_getLL('middle_name'));
		$subpartArray['###VALUE_DELIVERY_MIDDLE_NAME###']=htmlspecialchars($user['delivery_middle_name']);
		$subpartArray['###LABEL_DELIVERY_LAST_NAME###']=ucfirst($this->pi_getLL('last_name')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_DELIVERY_LAST_NAME###']=htmlspecialchars($user['delivery_last_name']);
		$subpartArray['###LABEL_DELIVERY_STREET_NAME###']=ucfirst($this->pi_getLL('street_address')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_DELIVERY_STREET_NAME###']=htmlspecialchars($user['delivery_street_name']);
		$subpartArray['###LABEL_DELIVERY_ADDRESS_NUMBER###']=ucfirst($this->pi_getLL('street_address_number')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_DELIVERY_ADDRESS_NUMBER###']=htmlspecialchars($user['delivery_address_number']);
		$subpartArray['###LABEL_DELIVERY_ADDRESS_EXT###']=ucfirst($this->pi_getLL('address_extension'));
		$subpartArray['###VALUE_DELIVERY_ADDRESS_EXT###']=htmlspecialchars($user['delivery_address_ext']);
		$subpartArray['###LABEL_DELIVERY_POSTCODE###']=ucfirst($this->pi_getLL('zip')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_DELIVERY_POSTCODE###']=htmlspecialchars($user['delivery_zip']);
		$subpartArray['###LABEL_DELIVERY_CITY###']=ucfirst($this->pi_getLL('city')).'<span class="text-danger">*</span>';
		$subpartArray['###VALUE_DELIVERY_CITY###']=htmlspecialchars($user['delivery_city']);
		$subpartArray['###DELIVERY_STATE_BLOCK###']=$state_delivery_block;
		$subpartArray['###DELIVERY_COUNTRY_BLOCK###']=$delivery_country_block;
		$subpartArray['###LABEL_DELIVERY_EMAIL###']=ucfirst($this->pi_getLL('e-mail_address'));
		$subpartArray['###VALUE_DELIVERY_EMAIL###']=htmlspecialchars($user['delivery_email']);
		$subpartArray['###LABEL_DELIVERY_TELEPHONE_NUMBER###']=ucfirst($this->pi_getLL('telephone')).($this->ms['MODULES']['CHECKOUT_REQUIRED_TELEPHONE']=='1' ? '<span class="text-danger">*</span>' : '');
		$subpartArray['###VALUE_DELIVERY_TELEPHONE_NUMBER###']=htmlspecialchars($user['delivery_telephone']);
		if ($this->ms['MODULES']['SHOW_MOBILE_NUMBER_INPUT_IN_CHECKOUT']) {
			$subpartArray['###BILLING_MOBILE_NUMBER_INPUT###']='<div class="account-field col-sm-6" id="input-mobile">
				<label for="mobile" id="account-mobile">'.ucfirst($this->pi_getLL('mobile')).'</label>
				<input type="text" name="mobile" id="mobile" class="mobile" value="'.htmlspecialchars($user['mobile']).'">
				<div id="invalid-mobile" class="error-space" style="display:none"></div>
			</div>';
			$subpartArray['###DELIVERY_MOBILE_NUMBER_INPUT###']='<div class="account-field col-sm-6" id="input-dfmobile">
				<label for="delivery_mobile" class="account_mobile">'.ucfirst($this->pi_getLL('mobile')).'</label>
				<input type="text" name="delivery_mobile" id="delivery_mobile" class="delivery_mobile" value="'.htmlspecialchars($user['delivery_mobile']).'">
				<div id="invalid-delivery_mobile" class="error-space" style="display:none"></div>
			</div>';
		} else {
			$subpartArray['###BILLING_MOBILE_NUMBER_INPUT###']='';
			$subpartArray['###DELIVERY_MOBILE_NUMBER_INPUT###']='';
		}
		$subpartArray['###LABEL_DELIVERY_ADDRESS###']=$this->pi_getLL('delivery_address');
		$subpartArray['###LABEL_PAYMENT_METHOD###']=$this->pi_getLL('choose_payment_method');
		$subpartArray['###PAYMENT_METHODS###']=$payment_method_block;
		$subpartArray['###LABEL_SHIPPING_METHOD###']=$this->pi_getLL('choose_shipping_method');
		$subpartArray['###SHIPPING_METHODS###']=$shipping_method_block;
		$subpartArray['###LABEL_REVIEW_YOUR_ORDER###']=$this->pi_getLL('review_your_order');
		$subpartArray['###TABLE_COLSPAN###']=$colspan;
		$subpartArray['###LABEL_COMMENTS###']=$this->pi_getLL('comments');
		$subpartArray['###BACK_TO_SHOPPINGCART_LINK###']=mslib_fe::typolink($this->shop_pid, 'tx_multishop_pi1[page_section]=shopping_cart');
		$subpartArray['###LABEL_BUTTON_BACK###']=$this->pi_getLL('back');
		$subpartArray['###LABEL_BUTTON_CONFIRM_ORDER###']=$this->pi_getLL('confirm_order');
		$subpartArray['###INVALID_FIRSTNAME_MESSAGE###']=$this->pi_getLL('first_name_required');
		$subpartArray['###INVALID_LASTNAME_MESSAGE###']=$this->pi_getLL('surname_is_required');
		$subpartArray['###INVALID_ADDRESS_MESSAGE###']=$this->pi_getLL('street_address_is_required');
		$subpartArray['###INVALID_ADDRESSNUMBER_MESSAGE###']=$this->pi_getLL('street_number_is_required');
		$subpartArray['###INVALID_ZIP_MESSAGE###']=$this->pi_getLL('zip_is_required');
		$subpartArray['###INVALID_CITY_MESSAGE###']=$this->pi_getLL('city_is_required');
		$subpartArray['###INVALID_EMAIL_MESSAGE###']=$this->pi_getLL('email_is_required');
		$subpartArray['###INVALID_EMAIL_MESSAGE_JS###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('email_is_required'));
		$subpartArray['###INVALID_EMAILCONFIRMATION_MESSAGE###']=$this->pi_getLL('email_is_required');
		$subpartArray['###INVALID_EMAILCONFIRMATION_MESSAGE_JS###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('email_is_required'));
		$subpartArray['###VERIFICATION_EMAIL_NOT_MATCH_JS1###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('verification_email_not_match'));
		$subpartArray['###VERIFICATION_EMAIL_NOT_MATCH_JS2###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('verification_email_not_match'));
		$subpartArray['###INVALID_MOBILE_MESSAGE###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('mobile_must_be_x_digits_long'));
		$subpartArray['###INVALID_MOBILE_MESSAGE2###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('mobile_must_be_x_digits_long'));
		$subpartArray['###MOBILE_NUMBER_LENGTH###']=$this->ms['MODULES']['CHECKOUT_LENGTH_TELEPHONE_NUMBER'];
		$subpartArray['###MOBILE_NUMBER_LENGTH2###']=$this->ms['MODULES']['CHECKOUT_LENGTH_TELEPHONE_NUMBER'];
		$subpartArray['###INVALID_DELIVERY_FIRSTNAME_MESSAGE###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('first_name_required').' ('.strtolower($this->pi_getLL('delivery_address')).')');
		$subpartArray['###INVALID_DELIVERY_LASTNAME_MESSAGE###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('surname_is_required').' ('.strtolower($this->pi_getLL('delivery_address')).')');
		$subpartArray['###INVALID_DELIVERY_ADDRESS_MESSAGE###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('street_address_is_required').' ('.strtolower($this->pi_getLL('delivery_address')).')');
		$subpartArray['###INVALID_DELIVERY_ADDRESSNUMBER_MESSAGE###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('street_number_is_required').' ('.strtolower($this->pi_getLL('delivery_address')).')');
		$subpartArray['###INVALID_DELIVERY_ZIP_MESSAGE###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('zip_is_required').' ('.strtolower($this->pi_getLL('delivery_address')).')');
		$subpartArray['###INVALID_DELIVERY_CITY_MESSAGE###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('city_is_required').' ('.strtolower($this->pi_getLL('delivery_address')).')');
		$subpartArray['###INVALID_DELIVERY_COUNTRY_MESSAGE###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('country_is_required').' ('.strtolower($this->pi_getLL('delivery_address')).')');
		$subpartArray['###INVALID_DELIVERY_GENDER_MESSAGE###']=\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('gender_is_required', 'Title is required').' ('.strtolower($this->pi_getLL('delivery_address')).')');
		$telephone_validation='';
		$mobile_validation='';
		$delivery_telephone_validation='';
		if ($this->ms['MODULES']['CHECKOUT_REQUIRED_TELEPHONE']=='1') {
			if (!$this->ms['MODULES']['CHECKOUT_LENGTH_TELEPHONE_NUMBER']) {
				$telephone_validation=' required="required" data-h5-errorid="invalid-telephone" title="'.$this->pi_getLL('telephone_is_required').'"';
				$mobile_validation=' required="required" data-h5-errorid="invalid-mobile" title="'.$this->pi_getLL('mobile_must_be_x_digits_long').'"';
			} else {
				$telephone_validation=' required="required" data-h5-errorid="invalid-telephone" title="'.$this->pi_getLL('telephone_is_required').'" pattern=".{'.$this->ms['MODULES']['CHECKOUT_LENGTH_TELEPHONE_NUMBER'].'}"';
				$mobile_validation=' required="required" data-h5-errorid="invalid-mobile" title="'.$this->pi_getLL('mobile_must_be_x_digits_long').'"';
			}
			$delivery_telephone_validation='
			$(\'#delivery_telephone\').attr(\'required\', \'required\');
            $(\'#delivery_telephone\').attr(\'data-h5-errorid\', \'invalid-delivery_telephone\');
			$(\'#delivery_telephone\').attr(\'title\', '.\TYPO3\CMS\Core\Utility\GeneralUtility::quoteJSvalue($this->pi_getLL('telephone_is_required').' ('.strtolower($this->pi_getLL('delivery_address')).')').');
			';
		}
		$subpartArray['###TELEPHONE_VALIDATION###']=$telephone_validation;
		$subpartArray['###MOBILE_VALIDATION###']=$mobile_validation;
		$subpartArray['###DELIVERY_TELEPHONE_VALIDATION###']=$delivery_telephone_validation;
		$subpartArray['###AJAX_URL_CHANGE_ATTRIBUTES###']=mslib_fe::typolink($this->shop_pid.',2002', 'tx_multishop_pi1[page_section]=custom_page&tx_multishoponestepcheckout_pi1[page_section]=change_product_attributes');
		$subpartArray['###AJAX_URL_UPDATE_ATTRIBUTES###']=mslib_fe::typolink($this->shop_pid.',2002', 'tx_multishop_pi1[page_section]=custom_page&tx_multishoponestepcheckout_pi1[page_section]=update_product_attributes');
		//
		$company_validation='';
		$delivery_company_validation='';
		if ($this->ms['MODULES']['CHECKOUT_REQUIRED_COMPANY']) {
			$company_validation=' required="required" data-h5-errorid="invalid-company" title="'.$this->pi_getLL('company_is_required').'"';
			$delivery_company_validation=' required="required" data-h5-errorid="invalid-delivery_company" title="'.$this->pi_getLL('company_is_required').'"';
		}
		$subpartArray['###COMPANY_VALIDATION###']=$company_validation;
		$subpartArray['###DELIVERY_COMPANY_VALIDATION###']=$delivery_company_validation;
		$subpartArray['###RIGHT_OF_WITHDRAWAL###']='';
		if ($this->ms['MODULES']['RIGHT_OF_WITHDRAWAL_CHECKBOX_IN_CHECKOUT']) {
			$right_of_withdrawal_label=$this->pi_getLL('click_here_if_you_agree_the_right_of_withdrawal');
			$page=mslib_fe::getCMScontent('right_of_withdrawal', $GLOBALS['TSFE']->sys_language_uid);
			if ($page[0]['content']) {
				$right_of_withdrawal_label.=' (<a href="'.mslib_fe::typolink($this->shop_pid, '&tx_multishop_pi1[page_section]=info&tx_multishop_pi1[cms_hash]='.$page[0]['hash']).'" target="_blank" class="read_right_of_withdrawal">'.$this->pi_getLL('view_right_of_withdrawal').'</a>)';
			}
			$subpartArray['###RIGHT_OF_WITHDRAWAL###']='
			<div class="checkboxAgreement right_of_withdrawal_container">
			    <div class="checkbox checkbox-success checkbox-inline">
				    <input name="tx_multishop_pi1[right_of_withdrawal]" class="right_of_withdrawal_checkbox_in_checkout" id="right_of_withdrawal_checkbox_in_checkout" type="checkbox" value="1" required="required" data-h5-errorid="invalid-row" title="'.htmlspecialchars($this->pi_getLL('you_havent_accepted_the_right_of_withdrawal')).'">
				    <label for="right_of_withdrawal_checkbox_in_checkout">'.$right_of_withdrawal_label.'</label>
				</div>
				<div id="invalid-row" class="error-space" style="display:none"></div>
			</div>
			';
		}
		//
		$privacy_statement_link='';
		if ($this->ms['MODULES']['DISPLAY_PRIVACY_STATEMENT_LINK_ON_CHECKOUT_PAGE']) {
			$page=mslib_fe::getCMScontent('privacy_statement', $GLOBALS['TSFE']->sys_language_uid);
			if ($page[0]['content']) {
				$privacy_statement_link='<div class="privacy_statement_link"><a href="'.mslib_fe::typolink($this->shop_pid, 'tx_multishop_pi1[page_section]=info&tx_multishop_pi1[cms_hash]='.$page[0]['hash']).'" target="_blank" class="read_privacy_statement"><span>'.$this->pi_getLL('view_privacy_statement').'</pan></a></div>';
			}
		}
		$subpartArray['###PRIVACY_STATEMENT_LINK###']=$privacy_statement_link;
		//
		$read_additional_customer_info_link='';
		if ($this->ms['MODULES']['ENABLE_CHECKOUT_CUSTOMER_INFO_LINK']) {
			$page=mslib_fe::getCMScontent('checkout_customer_info_page', $GLOBALS['TSFE']->sys_language_uid);
			if ($page[0]['content']) {
				$read_additional_customer_info_link='<div class="checkout_customer_info_page_link"><a href="'.mslib_fe::typolink($this->shop_pid, 'tx_multishop_pi1[page_section]=info&tx_multishop_pi1[cms_hash]='.$page[0]['hash']).'" target="_blank" class="read_customer_additional_info"><span>'.$this->pi_getLL('click_here_to_read_the_additional_customer_information').'</pan></a></div>';
			}
		}
		$subpartArray['###READ_ADDITIONAL_CUSTOMER_INFO_LINK###']=$read_additional_customer_info_link;
		// render password for create account
		$subpartArray['###PASSWORD_INPUT_BLOCK###']='';
		if (!mslib_fe::loggedin()) {
			$password_input_block='<div class="create_account_password">
			<h2>'.$this->pi_getLL('create_account').'</h2>
			<span>('.$this->pi_getLL('not_required').')</span>
			<div class="row">
				<div class="account-field col-sm-12" id="user-password">
					<label class="account-password" for="password">'.$this->pi_getLL('password').'</label>
					<input type="password" name="password" class="password" id="password" value="" />
					<span class="error-space"></span>
				</div>
				<div class="account-field col-sm-12" id="user-confirmpassword">
					<label class="account-password-confirm" for="password_confirm">'.$this->pi_getLL('repassword').'</label>
					<input type="password" name="password_confirm" class="password-confirm" id="password_confirm" value="" />
					<span class="error-space"></span>
				</div>
			</div>
		</div>';
			$subpartArray['###PASSWORD_INPUT_BLOCK###']=$password_input_block;
		}
		// newsletter
		$newsletter_optin='';
		if ($this->ms['MODULES']['DISPLAY_SUBSCRIBE_TO_NEWSLETTER_IN_CHECKOUT']) {
			$markerArray=array();
			$markerArray['NEWSLETTER_CHECKED']=(($user['tx_multishop_newsletter']) ? 'checked' : '');
			$markerArray['LABEL_SUBSCRIBE_TO_NEWSLETTER']=ucfirst($this->pi_getLL('subscribe_to_our_newsletter'));
			$newsletter_optin=$this->cObj->substituteMarkerArray($subparts['newsletter_optin'], $markerArray, '###|###');
		}
		$subpartArray['###NEWSLETTER_OPTIN###']=$newsletter_optin;
		// general condition checkbox
		$general_condition_checkbox = '<input name="accept_general_conditions" type="hidden" value="1"">';
		if (!$this->ms['MODULES']['HIDE_GENERAL_CONDITIONS_CHECKBOX_ON_CHECKOUT']) {
			$general_condition_checkbox = '
			<div class="checkboxAgreement accept_general_conditions_container">
				<div class="checkbox checkbox-success checkbox-inline">
					<input name="accept_general_conditions" class="accept_general_conditions" id="accept_general_conditions" type="checkbox" value="1" required="required" data-h5-errorid="invalid-tos" title="' . htmlspecialchars($this->pi_getLL('you_havent_accepted_the_general_conditions') . '.') . '">
					<label for="accept_general_conditions">' . $general_condition_label . '</label>
				</div>
				<div id="invalid-tos" class="error-space" style="display:none"></div>
			</div>
			';
		}
		$subpartArray['###GENERAL_CONDITIONS###'] = $general_condition_checkbox;
		// custom hook that can be controlled by third-party plugin
		if (is_array($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/scripts/front_pages/includes/checkout/multistep/checkout_address.php']['checkoutAddressPostHook'])) {
			$params=array(
				'subpartArray'=>&$subpartArray,
				'cart'=>&$cart
			);
			foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['ext/multishop/scripts/front_pages/includes/checkout/multistep/checkout_address.php']['checkoutAddressPostHook'] as $funcRef) {
				\TYPO3\CMS\Core\Utility\GeneralUtility::callUserFunction($funcRef, $params, $this);
			}
		}
		// custom hook that can be controlled by third-party plugin eof
		$content.=$this->cObj->substituteMarkerArrayCached($subparts['template'], array(), $subpartArray);
	}
}
?>